(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common'), require('@angular/platform-browser'), require('@angular/material/core'), require('@angular/material/icon'), require('@angular/material/list'), require('@angular/animations'), require('hammerjs'), require('@angular/flex-layout')) :
    typeof define === 'function' && define.amd ? define('mat-list-touch', ['exports', '@angular/core', '@angular/common', '@angular/platform-browser', '@angular/material/core', '@angular/material/icon', '@angular/material/list', '@angular/animations', 'hammerjs', '@angular/flex-layout'], factory) :
    (global = global || self, factory(global['mat-list-touch'] = {}, global.ng.core, global.ng.common, global.ng.platformBrowser, global.ng.material.core, global.ng.material.icon, global.ng.material.list, global.ng.animations, global.hammerjs, global.ng.flexLayout));
}(this, (function (exports, core, common, platformBrowser, core$1, icon, list, animations, hammerjs, flexLayout) { 'use strict';

    var MaterialImportModule = /** @class */ (function () {
        function MaterialImportModule() {
        }
        return MaterialImportModule;
    }());
    MaterialImportModule.decorators = [
        { type: core.NgModule, args: [{
                    imports: [
                        icon.MatIconModule,
                        list.MatListModule,
                        core$1.MatRippleModule
                    ],
                    declarations: [],
                    exports: [
                        icon.MatIconModule,
                        list.MatListModule,
                        core$1.MatRippleModule
                    ]
                },] }
    ];

    var Constants = {
        MAX_OFFSET: 500,
        MIN_OFFSET: 0,
        DEFAULT_THRESHOLD: 100,
        DEFAULT_LIMIT: 300,
    };
    var Warnings;
    (function (Warnings) {
        Warnings["ADDING_DEFAULT_SLIDE_THRESHOLD"] = "Will keep it default i.e.";
        Warnings["SLIDE_THRESHOLD_NOT_FOUND"] = "You have not provided the slideThreshold.";
        Warnings["ZERO_SLIDE_THRESHOLD_NOT_ALLOWED"] = "slideThreshold value can not be 0 or less than 0.";
        Warnings["MAX_OFFSET_EXCEEDED"] = "Swipe action threshold value should be less than 50.";
        Warnings["LIMIT_TOO_LOW"] = "Swipe limit should exceed threshold.";
        Warnings["INVALID_SLIDE_THRESHOLD_NOT_ALLOWED"] = "slideThreshold value is invalid, Expecting number between 0 to 50.";
    })(Warnings || (Warnings = {}));

    var offset = '50';
    var rowsAnimation = animations.trigger('rowsAnimation', [
        animations.transition('void => *', [
            animations.style({
                height: '*',
                opacity: '0',
                transform: 'translateY(' + (-offset).toString() + 'px)',
                'box-shadow': 'none'
            }),
            animations.sequence([
                animations.animate('.2s ease', animations.style({
                    height: '*',
                    opacity: '.2',
                    transform: 'translateX(0)',
                    'box-shadow': 'none'
                })),
                animations.animate('.35s ease', animations.style({ height: '*', opacity: 1, transform: 'translateX(0)' }))
            ])
        ]),
        animations.transition('* => void', [
            animations.style({ height: '*', opacity: '1', transform: 'translateX(0px) translateY(' + (-offset).toString() + 'px)', 'box-shadow': 'none' }),
            animations.sequence([
                animations.animate('.2s ease', animations.style({
                    height: '*',
                    opacity: 0,
                    transform: 'translateX(' + (-offset).toString() + 'px) translateY(' + (-offset).toString() + 'px)'
                }))
            ])
        ]),
    ]);

    var MatListTouchComponent = /** @class */ (function () {
        function MatListTouchComponent() {
            this.swipeLeftAction = new core.EventEmitter();
            this.swipeRightAction = new core.EventEmitter();
            this.tapAction = new core.EventEmitter();
            this.leftColor = 'green';
            this.leftIcon = 'check';
            this.rightColor = 'red';
            this.rightIcon = 'not_interested';
            this.defaultSwipeColor = 'gray';
            this.swipeThreshold = Constants.DEFAULT_THRESHOLD;
            this.swipeLimit = Constants.DEFAULT_LIMIT;
            this.silenceWarnings = false;
            this.currentSwipeColor = this.defaultSwipeColor;
            this.lastAnimatedIndex = null;
        }
        MatListTouchComponent.prototype.ngOnInit = function () {
            this.resetSwipeList();
        };
        MatListTouchComponent.prototype.evalLeftBorder = function (item, index) {
            if (this.leftBorderEval) {
                return this.leftBorderEval(item, index);
            }
            return '';
        };
        MatListTouchComponent.prototype.evalRightBorder = function (item, index) {
            if (this.rightBorderEval) {
                return this.rightBorderEval(item, index);
            }
            return '';
        };
        MatListTouchComponent.prototype.resetSwipeList = function () {
            this.setThreshold();
        };
        MatListTouchComponent.prototype.setThreshold = function () {
            if (this.swipeThreshold < Constants.MIN_OFFSET || this.swipeThreshold > Constants.MAX_OFFSET) {
                if (this.swipeThreshold > Constants.MAX_OFFSET) {
                    this.logWarnings(Warnings.MAX_OFFSET_EXCEEDED, Warnings.ADDING_DEFAULT_SLIDE_THRESHOLD + " " + Constants.DEFAULT_THRESHOLD + "%.");
                }
                if (this.swipeThreshold < Constants.MIN_OFFSET || this.swipeThreshold === Constants.MIN_OFFSET) {
                    this.logWarnings(Warnings.ZERO_SLIDE_THRESHOLD_NOT_ALLOWED, Warnings.ADDING_DEFAULT_SLIDE_THRESHOLD + " " + Constants.DEFAULT_THRESHOLD + "%.");
                }
                this.swipeThreshold = Constants.DEFAULT_THRESHOLD;
            }
            if (this.swipeLimit < this.swipeThreshold) {
                this.swipeLimit = 100 - this.swipeThreshold;
                this.logWarnings(Warnings.LIMIT_TOO_LOW);
            }
        };
        MatListTouchComponent.prototype.panMoveEvent = function (action, elementRef, item, index) {
            if (this.disableActionsEval && this.disableActionsEval(item, index)) {
                elementRef.style.left = 0;
                return;
            }
            if (!this.swipeLeftAction.observers.length && !this.swipeRightAction.observers.length) {
                elementRef.style.left = 0;
                return;
            }
            // DEBUG THIS HACK
            if (Math.abs(action.deltaY) > 50) {
                elementRef.style.left = 0;
                return;
            }
            var offset = action.deltaX;
            if (Math.abs(action.deltaX) < this.swipeLimit) {
                elementRef.style.left = action.deltaX + 'px';
            }
            else {
                if (action.deltaX > 0) {
                    elementRef.style.left = this.swipeLimit + 'px';
                }
                else {
                    elementRef.style.left = -this.swipeLimit + 'px';
                }
            }
            if (offset > this.swipeThreshold) {
                this.currentSwipeColor = this.leftColor;
            }
            else if (offset < -this.swipeThreshold) {
                this.currentSwipeColor = this.rightColor;
            }
            else {
                this.currentSwipeColor = this.defaultSwipeColor;
            }
        };
        MatListTouchComponent.prototype.panEndEvent = function (event, item, index) {
            if (event.deltaX > this.swipeThreshold) {
                this.emitLeftAction(index);
            }
            else if (event.deltaX < -this.swipeThreshold) {
                this.emitRightAction(index);
            }
            this.lastAnimatedIndex = index;
        };
        MatListTouchComponent.prototype.tapEvent = function (index) {
            var tapItem = this.dataSource[index];
            if (this.tapAction.observers) {
                this.tapAction.emit({
                    index: index,
                    data: tapItem
                });
            }
        };
        MatListTouchComponent.prototype.slideComplete = function (event) {
            event.element.style.left = '0px';
            this.lastAnimatedIndex = null;
        };
        MatListTouchComponent.prototype.emitLeftAction = function (index) {
            var actionItem = this.dataSource[index];
            if (this.swipeLeftAction.observers) {
                this.swipeLeftAction.emit({
                    index: index,
                    data: actionItem
                });
            }
        };
        MatListTouchComponent.prototype.emitRightAction = function (index) {
            var actionItem = this.dataSource[index];
            if (this.swipeRightAction.observers) {
                this.swipeRightAction.emit({
                    index: index,
                    data: actionItem
                });
            }
        };
        MatListTouchComponent.prototype.logWarnings = function (warningFor, extraMessage) {
            if (!this.silenceWarnings) {
                switch (warningFor) {
                    case Warnings.SLIDE_THRESHOLD_NOT_FOUND:
                    case Warnings.ZERO_SLIDE_THRESHOLD_NOT_ALLOWED:
                    case Warnings.MAX_OFFSET_EXCEEDED:
                    case Warnings.INVALID_SLIDE_THRESHOLD_NOT_ALLOWED:
                        extraMessage ?
                            console.warn(this.getConstValue(warningFor)) :
                            console.warn(this.getConstValue(warningFor), extraMessage);
                        break;
                }
            }
        };
        MatListTouchComponent.prototype.getConstValue = function (constantName) {
            return Warnings[constantName];
        };
        return MatListTouchComponent;
    }());
    MatListTouchComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'mat-list-touch',
                    template: "<mat-list *ngIf=\"dataSource\" class=\"list-canvas\" ngClass.gt-sm=\"list-canvas-big\">\n    <ng-container *ngFor=\"let item of dataSource; let i = index;\">\n        <mat-list-item class=\"separator\" *ngIf=\"separatorEval(dataSource, i)\">\n            <div fxLayout=\"column\" class=\"list-item-container stripe-angled\">\n                <ng-template ngFor let-item [ngForOf]=\"[item]\" [ngForTemplate]=\"separatorTemplate\">\n                </ng-template>\n            </div>\n        </mat-list-item>\n        <mat-list-item [@rowsAnimation]=\"\">\n            <div class=\"slide-action-indicator\" [ngStyle]=\"{'background-color': currentSwipeColor}\">\n                <i class=\"material-icons slide-action-icon\" *ngIf=\"swipeLeftAction.observers\">{{leftIcon}}</i>\n                <span>&nbsp;</span>\n                <i class=\"material-icons slide-action-icon\" *ngIf=\"swipeRightAction.observers\">{{rightIcon}}</i>\n            </div>\n            <div fxLayout=\"column\" style=\"width:100%; height:100%;\">\n                <div #element fxLayout=\"row\"\n                    [@slideRow]=\"lastAnimatedIndex === i\"\n                    (@slideRow.done)=slideComplete($event) \n                    (panend)=\"panEndEvent($event, element, i)\"\n                    (panleft)=\"panMoveEvent($event, element, item, i)\"\n                    (panright)=\"panMoveEvent($event, element, item, i)\" \n                    (tap)=\"tapEvent(i)\"\n                    class=\"list-item-container list-item-hoverable\"\n                    [ngStyle]=\"{'border-left': evalLeftBorder(item, i), 'border-right': evalRightBorder(item, i)}\">\n                    <div class=\"list-item-identity\">\n                        <ng-template ngFor let-item [ngForOf]=\"[item]\" [ngForTemplate]=\"identityTemplate\">\n                        </ng-template>\n                    </div>\n                    <ng-template ngFor let-item [ngForOf]=\"[item]\" [ngForTemplate]=\"contentTemplate\">\n                    </ng-template>\n                </div>\n                <mat-divider *ngIf=\"i !== (dataSource.length - 1)\"></mat-divider>\n            </div>\n        </mat-list-item>\n    </ng-container>\n</mat-list>\n",
                    encapsulation: core.ViewEncapsulation.None,
                    animations: [
                        animations.trigger('slideRow', [
                            animations.transition('* => *', animations.animate(100, animations.keyframes([
                                animations.style({ left: '*', offset: 0 }),
                                animations.style({ left: '0', offset: 1 }),
                            ])))
                        ]),
                        rowsAnimation,
                    ],
                    styles: [".list-canvas.mat-list-base{padding-top:0}.stripe-angled{background:repeating-linear-gradient(45deg,rgba(33,150,243,.1),rgba(33,150,243,.1) 5px,#f1f8ff 10px,#f1f8ff 20px);color:#000}.list-canvas mat-list-item{height:60px!important}.list-canvas mat-list-item .mat-list-item-content{overflow:hidden;padding:0!important}.list-canvas mat-list-item.separator{height:20px!important}.list-canvas .slide-action-indicator{align-items:center;background-color:green;display:flex;flex-shrink:0;height:100%;justify-content:space-between;position:absolute;width:100%}.list-canvas .slide-action-indicator .slide-action-icon{color:#f1f8ff;font-size:24px;height:24px;margin-left:16px;margin-right:16px;width:24px}.list-canvas .list-item-container{align-items:center;background-color:#fff;display:flex;flex-direction:row;height:inherit;position:relative;width:100%}.list-canvas .list-item-container>.list-item-identity{color:rgba(0,0,0,.8);padding-left:16px!important;padding-right:16px!important}.list-canvas .list-item-container>.list-item-details{padding-right:16px!important}.list-canvas-big mat-list-item{height:80px!important}.list-canvas-big .list-item-container>.list-item-identity{padding-left:24px!important;padding-right:24px!important}.list-canvas-big .list-item-container>.list-item-details{padding-right:24px!important}.list-item-hoverable:hover{background-color:#f0f8ff}"]
                },] }
    ];
    MatListTouchComponent.propDecorators = {
        contentTemplate: [{ type: core.ContentChild, args: ['contentTemplate', { static: true },] }],
        separatorTemplate: [{ type: core.ContentChild, args: ['separatorTemplate', { static: true },] }],
        identityTemplate: [{ type: core.ContentChild, args: ['identityTemplate', { static: true },] }],
        dataSource: [{ type: core.Input }],
        swipeLeftAction: [{ type: core.Output }],
        swipeRightAction: [{ type: core.Output }],
        tapAction: [{ type: core.Output }],
        separatorEval: [{ type: core.Input }],
        leftBorderEval: [{ type: core.Input }],
        rightBorderEval: [{ type: core.Input }],
        disableActionsEval: [{ type: core.Input }],
        leftColor: [{ type: core.Input }],
        leftIcon: [{ type: core.Input }],
        rightColor: [{ type: core.Input }],
        rightIcon: [{ type: core.Input }],
        defaultSwipeColor: [{ type: core.Input }],
        swipeThreshold: [{ type: core.Input }],
        swipeLimit: [{ type: core.Input }],
        silenceWarnings: [{ type: core.Input }]
    };

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b)
                if (b.hasOwnProperty(p))
                    d[p] = b[p]; };
        return extendStatics(d, b);
    };
    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }
    var __assign = function () {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s)
                    if (Object.prototype.hasOwnProperty.call(s, p))
                        t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };
    function __rest(s, e) {
        var t = {};
        for (var p in s)
            if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
                t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }
    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
            r = Reflect.decorate(decorators, target, key, desc);
        else
            for (var i = decorators.length - 1; i >= 0; i--)
                if (d = decorators[i])
                    r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }
    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); };
    }
    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
            return Reflect.metadata(metadataKey, metadataValue);
    }
    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try {
                step(generator.next(value));
            }
            catch (e) {
                reject(e);
            } }
            function rejected(value) { try {
                step(generator["throw"](value));
            }
            catch (e) {
                reject(e);
            } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }
    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function () { if (t[0] & 1)
                throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function () { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f)
                throw new TypeError("Generator is already executing.");
            while (_)
                try {
                    if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done)
                        return t;
                    if (y = 0, t)
                        op = [op[0] & 2, t.value];
                    switch (op[0]) {
                        case 0:
                        case 1:
                            t = op;
                            break;
                        case 4:
                            _.label++;
                            return { value: op[1], done: false };
                        case 5:
                            _.label++;
                            y = op[1];
                            op = [0];
                            continue;
                        case 7:
                            op = _.ops.pop();
                            _.trys.pop();
                            continue;
                        default:
                            if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                                _ = 0;
                                continue;
                            }
                            if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) {
                                _.label = op[1];
                                break;
                            }
                            if (op[0] === 6 && _.label < t[1]) {
                                _.label = t[1];
                                t = op;
                                break;
                            }
                            if (t && _.label < t[2]) {
                                _.label = t[2];
                                _.ops.push(op);
                                break;
                            }
                            if (t[2])
                                _.ops.pop();
                            _.trys.pop();
                            continue;
                    }
                    op = body.call(thisArg, _);
                }
                catch (e) {
                    op = [6, e];
                    y = 0;
                }
                finally {
                    f = t = 0;
                }
            if (op[0] & 5)
                throw op[1];
            return { value: op[0] ? op[1] : void 0, done: true };
        }
    }
    var __createBinding = Object.create ? (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        Object.defineProperty(o, k2, { enumerable: true, get: function () { return m[k]; } });
    }) : (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        o[k2] = m[k];
    });
    function __exportStar(m, exports) {
        for (var p in m)
            if (p !== "default" && !exports.hasOwnProperty(p))
                __createBinding(exports, m, p);
    }
    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m)
            return m.call(o);
        if (o && typeof o.length === "number")
            return {
                next: function () {
                    if (o && i >= o.length)
                        o = void 0;
                    return { value: o && o[i++], done: !o };
                }
            };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }
    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m)
            return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done)
                ar.push(r.value);
        }
        catch (error) {
            e = { error: error };
        }
        finally {
            try {
                if (r && !r.done && (m = i["return"]))
                    m.call(i);
            }
            finally {
                if (e)
                    throw e.error;
            }
        }
        return ar;
    }
    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }
    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++)
            s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    }
    ;
    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }
    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n])
            i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try {
            step(g[n](v));
        }
        catch (e) {
            settle(q[0][3], e);
        } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length)
            resume(q[0][0], q[0][1]); }
    }
    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }
    function __asyncValues(o) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function (v) { resolve({ value: v, done: d }); }, reject); }
    }
    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) {
            Object.defineProperty(cooked, "raw", { value: raw });
        }
        else {
            cooked.raw = raw;
        }
        return cooked;
    }
    ;
    var __setModuleDefault = Object.create ? (function (o, v) {
        Object.defineProperty(o, "default", { enumerable: true, value: v });
    }) : function (o, v) {
        o["default"] = v;
    };
    function __importStar(mod) {
        if (mod && mod.__esModule)
            return mod;
        var result = {};
        if (mod != null)
            for (var k in mod)
                if (Object.hasOwnProperty.call(mod, k))
                    __createBinding(result, mod, k);
        __setModuleDefault(result, mod);
        return result;
    }
    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }
    function __classPrivateFieldGet(receiver, privateMap) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to get private field on non-instance");
        }
        return privateMap.get(receiver);
    }
    function __classPrivateFieldSet(receiver, privateMap, value) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to set private field on non-instance");
        }
        privateMap.set(receiver, value);
        return value;
    }

    var GestureConfig = /** @class */ (function (_super) {
        __extends(GestureConfig, _super);
        function GestureConfig() {
            var _this = _super.apply(this, __spread(arguments)) || this;
            _this.overrides = {
                pan: {
                    enable: true,
                    touchAction: 'auto',
                    direction: hammerjs.DIRECTION_HORIZONTAL
                },
                pinch: {
                    enable: false
                },
                rotate: {
                    enable: false
                },
                swipe: {
                    enable: false
                }
            };
            return _this;
        }
        return GestureConfig;
    }(platformBrowser.HammerGestureConfig));
    GestureConfig.decorators = [
        { type: core.Injectable }
    ];

    var MatListTouchModule = /** @class */ (function () {
        function MatListTouchModule() {
        }
        return MatListTouchModule;
    }());
    MatListTouchModule.decorators = [
        { type: core.NgModule, args: [{
                    imports: [
                        common.CommonModule,
                        MaterialImportModule,
                        flexLayout.FlexLayoutModule,
                        platformBrowser.HammerModule
                    ],
                    declarations: [MatListTouchComponent],
                    exports: [
                        MatListTouchComponent
                    ],
                    providers: [{
                            provide: platformBrowser.HAMMER_GESTURE_CONFIG,
                            useClass: GestureConfig,
                        }]
                },] }
    ];

    /*
     * Public API Surface of mat-list-touch
     */

    /**
     * Generated bundle index. Do not edit.
     */

    exports.GestureConfig = GestureConfig;
    exports.MatListTouchModule = MatListTouchModule;
    exports.ɵa = MaterialImportModule;
    exports.ɵb = MatListTouchComponent;
    exports.ɵc = rowsAnimation;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=mat-list-touch.umd.js.map
