import { ElementRef, EventEmitter, OnInit, TemplateRef } from '@angular/core';
export interface TouchActionEvent {
    index: number;
    data: any;
}
export declare class MatListTouchComponent implements OnInit {
    contentTemplate: TemplateRef<ElementRef>;
    separatorTemplate: TemplateRef<ElementRef>;
    identityTemplate: TemplateRef<ElementRef>;
    dataSource: any[];
    swipeLeftAction: EventEmitter<TouchActionEvent>;
    swipeRightAction: EventEmitter<TouchActionEvent>;
    tapAction: EventEmitter<TouchActionEvent>;
    separatorEval?: (item: any, index: number) => boolean;
    leftBorderEval?: (item: any, index: number) => string;
    rightBorderEval?: (item: any, index: number) => string;
    disableActionsEval: (item: any, index: number) => boolean;
    leftColor?: string;
    leftIcon?: string;
    rightColor?: string;
    rightIcon?: string;
    defaultSwipeColor?: string;
    swipeThreshold?: number;
    swipeLimit?: number;
    silenceWarnings?: boolean;
    currentSwipeColor: string;
    lastAnimatedIndex: number;
    ngOnInit(): void;
    evalLeftBorder(item: any, index: number): string;
    evalRightBorder(item: any, index: number): string;
    resetSwipeList(): void;
    setThreshold(): void;
    panMoveEvent(action: any, elementRef: any, item: object, index: number): void;
    panEndEvent(event: any, item: object, index: number): void;
    tapEvent(index: any): void;
    slideComplete(event: any): void;
    emitLeftAction(index: any): void;
    emitRightAction(index: any): void;
    logWarnings(warningFor: string, extraMessage?: string): void;
    getConstValue(constantName: string): string;
}
